<template>
  <v-col justify="space-between">
    <v-col cols="12" md="auto">
      <bulk-data
        :username="responsibleFullName"
        :filename="currentBulk.bulkLoad.filename"
        :file-type="type"
        :request-date="date"
      />
    </v-col>

    <v-col cols="12" md="auto" class="upload-component">
      <bulk-results :view="view" />
    </v-col>
  </v-col>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import BulkData from '~/components/BulkLoad/RegisterBulkLoad/BulkData';
import BulkResults from '~/components/BulkLoad/BulkLoadDetails/BulkResults';

export default {
  name: 'BulkLoadDetails',
  components: {
    BulkResults,
    BulkData,
  },
  props: {
    id: {
      type: [String, Number],
      required: true,
    },
  },
  data: () => ({
    view: false,
    currentBulk: {
      bulkLoad: {
        id: 0,
        type: null,
        state: '',
        requestedAt: '',
        filename: '',
        sourceFileKey: '',
        errorSourceFileKey: null,
        successfulRegistered: 0,
        failedRegistered: 0,

      },
      responsible: {
        id: 0,
        names: '',
        fatherLastname: '',
        motherLastname: '',
      },
    },
    date: null,
    type: null,
    responsibleFullName: null,
    state: null,
  }),
  fetch(_) {
    // this.getCurrentBulk({ id: this.id });
  },
  computed: {
    ...mapState({
      bulk: state => state.bulk.currentBulk,
    }),
  },
  mounted() {
    this.getBulkLoad();
  },
  methods: {
    ...mapActions({
      getCurrentBulkLoad: 'bulk/getCurrentBulkLoad',
    }),
    async getBulkLoad() {
      await this.getCurrentBulkLoad({ id: this.id });
      this.currentBulk = this.bulk;
      this.initialize();
    },
    /** Initializes variables  */
    initialize() {
      const responsible = this.currentBulk.responsible;
      this.responsibleFullName = responsible.names + ' ' + responsible.fatherLastname + ' ' + responsible.motherLastname;
      this.date = this.currentBulk.bulkLoad.requestedAt;
      this.type = this.currentBulk.bulkLoad.type;
      this.state = this.currentBulk.bulkLoad.state;
      this.view = true;
    },
  },
};
</script>

<style>
.v-card__title {
  font-size: 1.5rem !important;
}
.upload-component {
  text-align-last: center;
}
.upload-button {
  text-align-last: center;
}
span.v-btn__content {
  margin-left: -1em;
}

</style>
